diff --git a/tools/check-moz-style/modules/cpplint.py b/tools/check-moz-style/modules/cpplint.py
index c01e82d450..12f1edb9f9 100644
--- a/tools/check-moz-style/modules/cpplint.py
+++ b/tools/check-moz-style/modules/cpplint.py
@@ -851,7 +851,7 @@ def check_for_copyright(filename, lines, error):
 
     # We'll say it should occur by line 10. Don't forget there's a
     # dummy line at the front.
-    for line in xrange(1, min(len(lines), 11)):
+    for line in range(1, min(len(lines), 11)):
         if re.search(r'Copyright|License', lines[line], re.I):
             break
     else:                       # means no copyright line was found
@@ -1391,7 +1391,7 @@ def check_for_function_lengths(filename, clean_lines, line_number,
 
     if starting_func:
         body_found = False
-        for start_line_number in xrange(line_number, clean_lines.num_lines()):
+        for start_line_number in range(line_number, clean_lines.num_lines()):
             start_line = lines[start_line_number]
             joined_line += ' ' + start_line.lstrip()
             if search(r'(;|})', start_line):  # Declarations and trivial functions
@@ -2085,7 +2085,7 @@ def get_line_width(line):
       The width of the line in column positions, accounting for Unicode
       combining characters and wide characters.
     """
-    if isinstance(line, unicode):
+    if isinstance(line, str):
         width = 0
         for c in unicodedata.normalize('NFC', line):
             if unicodedata.east_asian_width(c) in ('W', 'F'):
@@ -2809,7 +2809,7 @@ def check_for_include_what_you_use(filename, clean_lines, include_state, error,
     required = {}  # A map of header name to line_number and the template entity.
         # Example of required: { '<functional>': (1219, 'less<>') }
 
-    for line_number in xrange(clean_lines.num_lines()):
+    for line_number in range(clean_lines.num_lines()):
         line = clean_lines.elided[line_number]
         if not line or line[0] == '#':
             continue
@@ -2938,7 +2938,7 @@ def process_file_data(filename, file_extension, lines, error):
 
     remove_multi_line_comments(filename, lines, error)
     clean_lines = CleansedLines(lines)
-    for line in xrange(clean_lines.num_lines()):
+    for line in range(clean_lines.num_lines()):
         process_line(filename, file_extension, clean_lines, line,
                      include_state, function_state, class_state, error)
     class_state.check_finished(filename, error)
diff --git a/tools/check-moz-style/modules/logging.py b/tools/check-moz-style/modules/logging.py
index ea03a489c6..42d7148bbf 100644
--- a/tools/check-moz-style/modules/logging.py
+++ b/tools/check-moz-style/modules/logging.py
@@ -29,10 +29,11 @@
 #
 # WebKit's Python module for logging
 
+from __future__ import print_function
 import sys
 
 def log(string):
-    print >> sys.stderr, string
+    print(string, file=sys.stderr)
 
 def error(string):
     log("ERROR: " + string)
diff --git a/tools/check-moz-style/modules/scm.py b/tools/check-moz-style/modules/scm.py
index e7cb9ffc60..07b9aa3ddd 100644
--- a/tools/check-moz-style/modules/scm.py
+++ b/tools/check-moz-style/modules/scm.py
@@ -29,6 +29,7 @@
 #
 # Python module for interacting with an SCM system (like SVN or Git)
 
+from __future__ import print_function
 import os
 import re
 import subprocess
@@ -118,7 +119,7 @@ class SCM:
 
     def ensure_clean_working_directory(self, force):
         if not force and not self.working_directory_is_clean():
-            print self.run_command(self.status_command(), raise_on_failure=False)
+            print(self.run_command(self.status_command(), raise_on_failure=False))
             error("Working directory has modifications, pass --force-clean or --no-clean to continue.")
         
         log("Cleaning working directory")
@@ -157,45 +158,45 @@ class SCM:
 
     @staticmethod
     def in_working_directory(path):
-        raise NotImplementedError, "subclasses must implement"
+        raise NotImplementedError("subclasses must implement")
 
     @staticmethod
     def find_checkout_root(path):
-        raise NotImplementedError, "subclasses must implement"
+        raise NotImplementedError("subclasses must implement")
 
     @staticmethod
     def commit_success_regexp():
-        raise NotImplementedError, "subclasses must implement"
+        raise NotImplementedError("subclasses must implement")
 
     def working_directory_is_clean(self):
-        raise NotImplementedError, "subclasses must implement"
+        raise NotImplementedError("subclasses must implement")
 
     def clean_working_directory(self):
-        raise NotImplementedError, "subclasses must implement"
+        raise NotImplementedError("subclasses must implement")
 
     def update_webkit(self):
-        raise NotImplementedError, "subclasses must implement"
+        raise NotImplementedError("subclasses must implement")
 
     def status_command(self):
-        raise NotImplementedError, "subclasses must implement"
+        raise NotImplementedError("subclasses must implement")
 
     def changed_files(self):
-        raise NotImplementedError, "subclasses must implement"
+        raise NotImplementedError("subclasses must implement")
 
     def display_name(self):
-        raise NotImplementedError, "subclasses must implement"
+        raise NotImplementedError("subclasses must implement")
 
     def create_patch(self):
-        raise NotImplementedError, "subclasses must implement"
+        raise NotImplementedError("subclasses must implement")
 
     def commit_with_message(self, message):
-        raise NotImplementedError, "subclasses must implement"
+        raise NotImplementedError("subclasses must implement")
     
     # Subclasses must indicate if they support local commits,
     # but the SCM baseclass will only call local_commits methods when this is true.
     @staticmethod
     def supports_local_commits():
-        raise NotImplementedError, "subclasses must implement"
+        raise NotImplementedError("subclasses must implement")
 
     def create_patch_from_local_commit(self, commit_id):
         pass
diff --git a/tools/lint/eslint.lint b/tools/lint/eslint.lint
index a2d864f75f..9b14160403 100644
--- a/tools/lint/eslint.lint
+++ b/tools/lint/eslint.lint
@@ -10,8 +10,31 @@ import re
 import signal
 import subprocess
 import sys
-from distutils.version import LooseVersion
-
+try:
+    from distutils.version import LooseVersion
+except ImportError:
+    import re as _re
+    class LooseVersion:
+        def __init__(self, vstring):
+            self.vstring = vstring
+            self.version = [int(x) if x.isdigit() else x for x in _re.split(r'[.\-]', vstring)]
+        def __str__(self): return self.vstring
+        def __repr__(self): return "LooseVersion ('%s')" % str(self)
+        def _cmp(self, other):
+            if not isinstance(other, LooseVersion): other = LooseVersion(other)
+            a, b = self.version, other.version
+            for i in range(max(len(a), len(b))):
+                va = a[i] if i < len(a) else 0
+                vb = b[i] if i < len(b) else 0
+                if type(va) != type(vb): va, vb = str(va), str(vb)
+                if va < vb: return -1
+                if va > vb: return 1
+            return 0
+        def __eq__(self, other): return self._cmp(other) == 0
+        def __lt__(self, other): return self._cmp(other) < 0
+        def __le__(self, other): return self._cmp(other) <= 0
+        def __gt__(self, other): return self._cmp(other) > 0
+        def __ge__(self, other): return self._cmp(other) >= 0
 import which
 from mozprocess import ProcessHandler
 
diff --git a/tools/mach_commands.py b/tools/mach_commands.py
index 898073bb63..1c67fa68bb 100644
--- a/tools/mach_commands.py
+++ b/tools/mach_commands.py
@@ -4,6 +4,7 @@
 
 from __future__ import absolute_import, unicode_literals
 
+from __future__ import print_function
 import sys
 import os
 import stat
@@ -75,9 +76,9 @@ class UUIDProvider(object):
                 print('')
         if format in [None, 'cpp', 'c++']:
             u = u.hex
-            print('{ 0x%s, 0x%s, 0x%s, \\' % (u[0:8], u[8:12], u[12:16]))
-            pairs = tuple(map(lambda n: u[n:n+2], range(16, 32, 2)))
-            print(('  { ' + '0x%s, ' * 7 + '0x%s } }') % pairs)
+            print(('{ 0x%s, 0x%s, 0x%s, \\' % (u[0:8], u[8:12], u[12:16])))
+            pairs = tuple([u[n:n+2] for n in range(16, 32, 2)])
+            print((('  { ' + '0x%s, ' * 7 + '0x%s } }') % pairs))
 
 
 @CommandProvider
@@ -92,7 +93,7 @@ class RageProvider(MachCommandBase):
         form where you can submit feedback. Just close the tab when done.
         """
         import getpass
-        import urllib
+        import six.moves.urllib.request, six.moves.urllib.parse, six.moves.urllib.error
         import webbrowser
 
         # Try to resolve the current user.
@@ -127,7 +128,7 @@ class RageProvider(MachCommandBase):
 
         url = 'https://docs.google.com/a/mozilla.com/forms/d/e/1FAIpQLSeDVC3IXJu5d33Hp_ZTCOw06xEUiYH1pBjAqJ1g_y63sO2vvA/viewform'
         if user:
-            url += '?entry.1281044204=%s' % urllib.quote(user)
+            url += '?entry.1281044204=%s' % six.moves.urllib.parse.quote(user)
 
         print('Please leave your feedback in the opened web form')
         webbrowser.open_new_tab(url)
@@ -148,8 +149,8 @@ class PastebinProvider(object):
                      help='Specify the file to upload to pastebin.mozilla.org')
 
     def pastebin(self, language, poster, duration, file):
-        import urllib
-        import urllib2
+        import six.moves.urllib.request, six.moves.urllib.parse, six.moves.urllib.error
+        import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 
         URL = 'https://pastebin.mozilla.org/'
 
@@ -183,7 +184,7 @@ class PastebinProvider(object):
                 extension = file.split('.')[-1]
                 for l in FILE_TYPES:
                     if extension == l['extension']:
-                        print('Identified file as %s' % l['name'])
+                        print(('Identified file as %s' % l['name']))
                         lang = l['value']
             except IOError:
                 print('ERROR. No such file')
@@ -204,18 +205,18 @@ class PastebinProvider(object):
             ('expiry', duration),
             ('paste', 'Send')]
 
-        data = urllib.urlencode(params)
+        data = six.moves.urllib.parse.urlencode(params)
         print('Uploading ...')
         try:
-            req = urllib2.Request(URL, data)
-            response = urllib2.urlopen(req)
+            req = six.moves.urllib.request.Request(URL, data)
+            response = six.moves.urllib.request.urlopen(req)
             http_response_code = response.getcode()
             if http_response_code == 200:
-                print(response.geturl())
+                print((response.geturl()))
             else:
-                print('Could not upload the file, '
-                      'HTTP Response Code %s' %(http_response_code))
-        except urllib2.URLError:
+                print(('Could not upload the file, '
+                      'HTTP Response Code %s' %(http_response_code)))
+        except six.moves.urllib.error.URLError:
             print('ERROR. Could not connect to pastebin.mozilla.org.')
             return 1
         return 0
@@ -228,7 +229,7 @@ class FormatProvider(MachCommandBase):
     @CommandArgument('--show', '-s', action = 'store_true',
         help = 'Show diff output on instead of applying changes')
     def clang_format(self, show=False):
-        import urllib2
+        import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 
         plat = platform.system()
         fmt = plat.lower() + "/clang-format-3.5"
@@ -242,8 +243,8 @@ class FormatProvider(MachCommandBase):
         else:
             arch = os.uname()[4]
             if (plat != "Linux" and plat != "Darwin") or arch != 'x86_64':
-                print("Unsupported platform " + plat + "/" + arch +
-                      ". Supported platforms are Windows/*, Linux/x86_64 and Darwin/x86_64")
+                print(("Unsupported platform " + plat + "/" + arch +
+                      ". Supported platforms are Windows/*, Linux/x86_64 and Darwin/x86_64"))
                 return 1
 
         os.chdir(self.topsrcdir)
@@ -256,8 +257,8 @@ class FormatProvider(MachCommandBase):
             if not clang_format_diff:
                 return 1
 
-        except urllib2.HTTPError as e:
-            print("HTTP error {0}: {1}".format(e.code, e.reason))
+        except six.moves.urllib.error.HTTPError as e:
+            print(("HTTP error {0}: {1}".format(e.code, e.reason)))
             return 1
 
         from subprocess import Popen, PIPE
@@ -276,7 +277,7 @@ class FormatProvider(MachCommandBase):
                 if e.errno == errno.ENOENT:
                     print("Can't find filterdiff. Please install patchutils.")
                 else:
-                    print("OSError {0}: {1}".format(e.code, e.reason))
+                    print(("OSError {0}: {1}".format(e.code, e.reason)))
                 return 1
 
 
@@ -290,14 +291,14 @@ class FormatProvider(MachCommandBase):
         target = os.path.join(self._mach_context.state_dir, os.path.basename(root))
         if not os.path.exists(target):
             site = "https://people.mozilla.org/~ajones/clang-format/"
-            if self.prompt and raw_input("Download clang-format executables from {0} (yN)? ".format(site)).lower() != 'y':
+            if self.prompt and input("Download clang-format executables from {0} (yN)? ".format(site)).lower() != 'y':
                 print("Download aborted.")
                 return 1
             self.prompt = False
 
             u = site + root
-            print("Downloading {0} to {1}".format(u, target))
-            data = urllib2.urlopen(url=u).read()
+            print(("Downloading {0} to {1}".format(u, target)))
+            data = six.moves.urllib.request.urlopen(url=u).read()
             temp = target + ".tmp"
             with open(temp, "wb") as fh:
                 fh.write(data)
@@ -340,8 +341,8 @@ def mozregression_create_parser():
                 'install',
                 'mozregression==%s' % release
             ])
-            print("mozregression was updated to version %s. please"
-                  " re-run your command." % release)
+            print(("mozregression was updated to version %s. please"
+                  " re-run your command." % release))
         else:
             # mozregression is up to date, return the parser.
             return mozregression.parser()
diff --git a/tools/power/mach_commands.py b/tools/power/mach_commands.py
index 281e7a868e..587e717a39 100644
--- a/tools/power/mach_commands.py
+++ b/tools/power/mach_commands.py
@@ -4,7 +4,7 @@
 
 from __future__ import print_function
 
-from distutils.version import StrictVersion
+# StrictVersion replaced
 
 from mach.decorators import (
     Command,
diff --git a/tools/profiler/merge-profiles.py b/tools/profiler/merge-profiles.py
index 0c10c60e1d..5037030841 100755
--- a/tools/profiler/merge-profiles.py
+++ b/tools/profiler/merge-profiles.py
@@ -5,6 +5,7 @@
 # is used to syncronized the samples. Each thread is moved into the merged
 # profile.
 #
+from __future__ import print_function
 import json
 import re
 import sys
@@ -107,7 +108,7 @@ if len(sys.argv) > 1:
     MergeProfiles(sys.argv[1:])
     sys.exit(0)
 
-print "Usage: merge-profile.py profile_<pid1>_<pname1>.sym profile_<pid2>_<pname2>.sym > merged.sym"
+print("Usage: merge-profile.py profile_<pid1>_<pname1>.sym profile_<pid2>_<pname2>.sym > merged.sym")
 
 
 
diff --git a/tools/profiler/nm-symbolicate.py b/tools/profiler/nm-symbolicate.py
index f51d7f75f5..9b380ad9df 100755
--- a/tools/profiler/nm-symbolicate.py
+++ b/tools/profiler/nm-symbolicate.py
@@ -4,6 +4,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import sys, subprocess, os
 
 def NMSymbolicate(library, addresses):
@@ -34,15 +35,15 @@ def NMSymbolicate(library, addresses):
         symbolForAddress = symbol
         break
     if symbolForAddress:
-      print symbolForAddress["funcName"]
+      print(symbolForAddress["funcName"])
     else:
-      print "??" # match addr2line
-    print ":0" # no line information from nm
+      print("??") # match addr2line
+    print(":0") # no line information from nm
 
 if len(sys.argv) > 1:
     NMSymbolicate(sys.argv[1], sys.argv[2:])
     sys.exit(0)
 
-print "Usage: nm-symbolicate.py <library> <addresses> > merged.sym"
+print("Usage: nm-symbolicate.py <library> <addresses> > merged.sym")
 
 
diff --git a/tools/rb/find_leakers.py b/tools/rb/find_leakers.py
index 4405d7a179..3f32f7d4b6 100755
--- a/tools/rb/find_leakers.py
+++ b/tools/rb/find_leakers.py
@@ -10,21 +10,22 @@
 # Please see README file in the same directory.
 
 
+from __future__ import print_function
 import sys
 
 def print_output(allocation, obj_to_class):
     '''Formats and prints output.'''
     items = []
-    for obj, count, in allocation.iteritems():
+    for obj, count, in allocation.items():
         # Adding items to a list, so we can sort them.
         items.append((obj, count))
     # Sorting by count.
     items.sort(key=lambda item: item[1])
 
     for obj, count, in items:
-        print "{obj} ({count}) @ {class_name}".format(obj=obj,
+        print("{obj} ({count}) @ {class_name}".format(obj=obj,
                                                       count=count,
-                                                      class_name=obj_to_class[obj])
+                                                      class_name=obj_to_class[obj]))
 
 def process_log(log_lines):
     '''Process through the log lines, and print out the result.
@@ -63,8 +64,8 @@ def process_log(log_lines):
             #     <nsStringBuffer> 0x01AFD3B8 1 Release 0
             #     <PStreamNotifyParent> 0x08880BD0 8 Dtor (20)
             if obj not in allocation:
-                print "An object was released that wasn't allocated!",
-                print obj, "@", class_name
+                print("An object was released that wasn't allocated!", end=' ')
+                print(obj, "@", class_name)
             else:
                 allocation.pop(obj)
             obj_to_class.pop(obj)
@@ -74,12 +75,12 @@ def process_log(log_lines):
 
 
 def print_usage():
-    print
-    print "Usage: find-leakers.py [log-file]"
-    print
-    print "If `log-file' provided, it will read that as the input log."
-    print "Else, it will read the stdin as the input log."
-    print
+    print()
+    print("Usage: find-leakers.py [log-file]")
+    print()
+    print("If `log-file' provided, it will read that as the input log.")
+    print("Else, it will read the stdin as the input log.")
+    print()
 
 def main():
     '''Main method of the script.'''
@@ -92,7 +93,7 @@ def main():
             log_lines = log_file.readlines()
         process_log(log_lines)
     else:
-        print 'ERROR: Invalid number of arguments'
+        print('ERROR: Invalid number of arguments')
         print_usage()
 
 if __name__ == '__main__':
diff --git a/tools/rb/fix_linux_stack.py b/tools/rb/fix_linux_stack.py
index 146e6eebdf..64a0ca76ae 100755
--- a/tools/rb/fix_linux_stack.py
+++ b/tools/rb/fix_linux_stack.py
@@ -7,6 +7,7 @@
 # produced by NS_FormatCodeAddress(), which on Linux often lack a function
 # name, a file name and a line number.
 
+from __future__ import print_function
 import subprocess
 import sys
 import re
@@ -40,7 +41,7 @@ class unbufferedLineConverter:
     def test():
         assert unbufferedLineConverter("rev").convert("123") == "321"
         assert unbufferedLineConverter("cut", ["-c3"]).convert("abcde") == "c"
-        print "Pass"
+        print("Pass")
 
 objdump_section_re = re.compile("^ [0-9a-f]* ([0-9a-f ]{8}) ([0-9a-f ]{8}) ([0-9a-f ]{8}) ([0-9a-f ]{8}).*")
 def elf_section(file, section):
@@ -173,11 +174,11 @@ def separate_debug_file_for(file):
 
     def word32(s):
         if type(s) != str or len(s) != 4:
-            raise StandardError("expected 4 byte string input")
+            raise Exception("expected 4 byte string input")
         s = list(s)
         if endian == "big":
             s.reverse()
-        return sum(map(lambda idx: ord(s[idx]) * (256 ** idx), range(0, 4)))
+        return sum([ord(s[idx]) * (256 ** idx) for idx in range(0, 4)])
 
     buildid = elf_section(file, ".note.gnu.build-id");
     if buildid is not None:
@@ -192,7 +193,7 @@ def separate_debug_file_for(file):
            note_header[12:16] != "GNU\0":
             sys.stderr.write("malformed .note.gnu.build_id in " + file + "\n")
         else:
-            buildid = "".join(map(lambda ch: "%02X" % ord(ch), buildid)).lower()
+            buildid = "".join(["%02X" % ord(ch) for ch in buildid]).lower()
             f = os.path.join(global_debug_dir, ".build-id", buildid[0:2], buildid[2:] + ".debug")
             if have_debug_file(f):
                 return f
diff --git a/tools/rb/fix_macosx_stack.py b/tools/rb/fix_macosx_stack.py
index 32831e9134..e1b63a8675 100755
--- a/tools/rb/fix_macosx_stack.py
+++ b/tools/rb/fix_macosx_stack.py
@@ -7,6 +7,7 @@
 # NS_FormatCodeAddress(), which on Mac often lack a file name and a line
 # number.
 
+from __future__ import print_function
 import subprocess
 import sys
 import re
@@ -39,7 +40,7 @@ class unbufferedLineConverter:
     def test():
         assert unbufferedLineConverter("rev").convert("123") == "321"
         assert unbufferedLineConverter("cut", ["-c3"]).convert("abcde") == "c"
-        print "Pass"
+        print("Pass")
 
 def separate_debug_file_for(file):
     return None
@@ -56,13 +57,13 @@ def address_adjustment(file):
             if line == "  segname __TEXT\n":
                 line = otool.stdout.readline()
                 if not line.startswith("   vmaddr "):
-                    raise StandardError("unexpected otool output")
+                    raise Exception("unexpected otool output")
                 result = int(line[10:], 16)
                 break
         otool.stdout.close()
 
         if result is None:
-            raise StandardError("unexpected otool output")
+            raise Exception("unexpected otool output")
 
         address_adjustments[file] = result
 
diff --git a/tools/rb/fix_stack_using_bpsyms.py b/tools/rb/fix_stack_using_bpsyms.py
index 5d04cd02a1..798aaf8fc7 100755
--- a/tools/rb/fix_stack_using_bpsyms.py
+++ b/tools/rb/fix_stack_using_bpsyms.py
@@ -10,6 +10,7 @@
 
 from __future__ import with_statement
 
+from __future__ import print_function
 import sys
 import os
 import re
@@ -160,4 +161,4 @@ def fixSymbols(line, symbolsDir):
 if __name__ == "__main__":
   symbolsDir = sys.argv[1]
   for line in iter(sys.stdin.readline, ''):
-    print fixSymbols(line, symbolsDir),
+    print(fixSymbols(line, symbolsDir), end=' ')
diff --git a/tools/update-packaging/generatesnippet.py b/tools/update-packaging/generatesnippet.py
index 15b7edf588..8fb2abbe44 100644
--- a/tools/update-packaging/generatesnippet.py
+++ b/tools/update-packaging/generatesnippet.py
@@ -7,9 +7,10 @@ This script generates the complete snippet for a given locale or en-US
 Most of the parameters received are to generate the MAR's download URL
 and determine the MAR's filename
 """
+from __future__ import print_function
 import sys, os, platform, sha
 from optparse import OptionParser
-from ConfigParser import ConfigParser
+from configparser import ConfigParser
 from stat import ST_SIZE
 
 def main():
@@ -80,7 +81,7 @@ def main():
 
     if options.verbose:
         # Show in our logs what the contents of the snippet are
-        print snippet
+        print(snippet)
 
 def generateSnippet(abstDistDir, applicationIniFile, locale,
                     downloadBaseURL, product, platform, branch):
@@ -88,7 +89,8 @@ def generateSnippet(abstDistDir, applicationIniFile, locale,
     c = ConfigParser()
     try:
         c.readfp(open(applicationIniFile))
-    except IOError, (stderror):
+    except IOError as xxx_todo_changeme:
+       (stderror) = xxx_todo_changeme
        sys.exit(stderror)
     buildid = c.get("App", "BuildID")
     appVersion = c.get("App", "Version")
@@ -141,7 +143,8 @@ def getFileHashAndSize(filepath):
         shaObj = sha.new(f.read())
         sha1Hash = shaObj.hexdigest()
         size = os.stat(filepath)[ST_SIZE]
-    except IOError, (stderror):
+    except IOError as xxx_todo_changeme1:
+       (stderror) = xxx_todo_changeme1
        sys.exit(stderror)
 
     return (sha1Hash, size)
